//
//  SettingsViewController.m
//  geowiki
//
//  Created by Dave Rahmany on 2/26/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "SettingsViewController.h"
#import "geowikiAppDelegate.h"


//Cell Properties
#define ROW_HEIGHT 40
#define CELL_WIDTH 320.0
#define LABEL_HEIGHT 20

//Dimensions of two columns
//Set offset and width
#define	NUMBER_OFFSET 10.0
#define NUMBER_WIDTH 50.0
#define NUMBER_TAG 1

#define TEXT_OFFSET 60.0
#define TEXT_WIDTH 270.0
#define	TEXT_TAG 2
@implementation SettingsViewController
@synthesize listOfItems;
//@synthesize settingsView;
@synthesize settingsTableView;
@synthesize isActive;




/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/
/*- (id) initWithCoder:(NSCoder *)aDecoder {
	if(self = [super initWithCoder:aDecoder])
	{
		self.title = @"Locations";
		//self.tableView.delegate = self;
	}
	return self;
}*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	
	//NSLog(@"settings");
    [super viewDidLoad];
	
	listOfItems = [[NSMutableArray alloc] init];
	[listOfItems addObject:@"Purdue"];
	self.settingsTableView.delegate = self;
	self.navigationItem.title = @"Categories";
	isActive = NO;
}





- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	return 1;
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    geowikiAppDelegate * appDelegate = (geowikiAppDelegate *) [[UIApplication sharedApplication] delegate];
    return [appDelegate numberOfCategories];
}


- (UITableViewCellAccessoryType)tableView:(UITableView *)tableView accessoryTypeForRowWithIndexPath:(NSIndexPath *)indexPath
{
	UITableViewCellAccessoryType accessory;
	
	geowikiAppDelegate * appDelegate = (geowikiAppDelegate *) [[UIApplication sharedApplication] delegate];
	NSString * toggledFilter = [appDelegate.categoryFilters objectAtIndex:indexPath.row];
	if(toggledFilter == @"YES")
	{
	    accessory = UITableViewCellAccessoryCheckmark;
	}
	else
	{
		accessory = UITableViewCellAccessoryNone;
	}
    //NSLog(@"inside accessoryTypeForRowWithIndexPath %d", indexPath.row);
	return (accessory);
}



- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    geowikiAppDelegate * appDelegate = (geowikiAppDelegate *) [[UIApplication sharedApplication] delegate];
	
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[LocationCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
	}
    
	cell.text = [NSString stringWithFormat:@"%@", [appDelegate.categories objectAtIndex:indexPath.row]];
    //NSLog(@"inside cellForRowAtIndexPath %d", indexPath.row);
	
	return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	
	geowikiAppDelegate * appDelegate = (geowikiAppDelegate *) [[UIApplication sharedApplication] delegate];
	[tableView deselectRowAtIndexPath:[tableView indexPathForSelectedRow] animated:NO];
	NSString * toggledFilter = [appDelegate.categoryFilters objectAtIndex:indexPath.row];
	//NSLog(@"Toggled Filter = %@  At Index = %d", toggledFilter, indexPath.row);
	if(toggledFilter == @"YES")
	{
		[tableView cellForRowAtIndexPath:indexPath].accessoryType = UITableViewCellAccessoryNone; 
		toggledFilter = @"NO";
	}
	else
	{
		[tableView cellForRowAtIndexPath:indexPath].accessoryType = UITableViewCellAccessoryCheckmark; 
		toggledFilter = @"YES";
	}
	
	[appDelegate.categoryFilters replaceObjectAtIndex:indexPath.row withObject:toggledFilter];
	
	//reload table view with filter applied
	[appDelegate filterTable];
}



		
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
	//[listOfItems release];
    [super dealloc];
}


@end
